<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPayment.PaymentSearchData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPayment.PaymentSearchData
 * @subpackage Arrays
 */
class ArrayOfPayment_PaymentSearchData extends AbstractStructArrayBase
{
    /**
     * The Payment_PaymentSearchData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\Payment_PaymentSearchData[]
     */
    public $Payment_PaymentSearchData;
    /**
     * Constructor method for ArrayOfPayment.PaymentSearchData
     * @uses ArrayOfPayment_PaymentSearchData::setPayment_PaymentSearchData()
     * @param \patest\StructType\Payment_PaymentSearchData[] $payment_PaymentSearchData
     */
    public function __construct(array $payment_PaymentSearchData = array())
    {
        $this
            ->setPayment_PaymentSearchData($payment_PaymentSearchData);
    }
    /**
     * Get Payment_PaymentSearchData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\Payment_PaymentSearchData[]|null
     */
    public function getPayment_PaymentSearchData()
    {
        return isset($this->{'Payment.PaymentSearchData'}) ? $this->{'Payment.PaymentSearchData'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPayment_PaymentSearchData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPayment_PaymentSearchData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePayment_PaymentSearchDataForArrayConstraintsFromSetPayment_PaymentSearchData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPayment_PaymentSearchDataPayment_PaymentSearchDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPayment_PaymentSearchDataPayment_PaymentSearchDataItem instanceof \patest\StructType\Payment_PaymentSearchData) {
                $invalidValues[] = is_object($arrayOfPayment_PaymentSearchDataPayment_PaymentSearchDataItem) ? get_class($arrayOfPayment_PaymentSearchDataPayment_PaymentSearchDataItem) : sprintf('%s(%s)', gettype($arrayOfPayment_PaymentSearchDataPayment_PaymentSearchDataItem), var_export($arrayOfPayment_PaymentSearchDataPayment_PaymentSearchDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Payment_PaymentSearchData property can only contain items of type \patest\StructType\Payment_PaymentSearchData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Payment_PaymentSearchData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Payment_PaymentSearchData[] $payment_PaymentSearchData
     * @return \patest\ArrayType\ArrayOfPayment_PaymentSearchData
     */
    public function setPayment_PaymentSearchData(array $payment_PaymentSearchData = array())
    {
        // validation for constraint: array
        if ('' !== ($payment_PaymentSearchDataArrayErrorMessage = self::validatePayment_PaymentSearchDataForArrayConstraintsFromSetPayment_PaymentSearchData($payment_PaymentSearchData))) {
            throw new \InvalidArgumentException($payment_PaymentSearchDataArrayErrorMessage, __LINE__);
        }
        if (is_null($payment_PaymentSearchData) || (is_array($payment_PaymentSearchData) && empty($payment_PaymentSearchData))) {
            unset($this->Payment_PaymentSearchData, $this->{'Payment.PaymentSearchData'});
        } else {
            $this->Payment_PaymentSearchData = $this->{'Payment.PaymentSearchData'} = $payment_PaymentSearchData;
        }
        return $this;
    }
    /**
     * Add item to Payment_PaymentSearchData value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Payment_PaymentSearchData $item
     * @return \patest\ArrayType\ArrayOfPayment_PaymentSearchData
     */
    public function addToPayment_PaymentSearchData(\patest\StructType\Payment_PaymentSearchData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\Payment_PaymentSearchData) {
            throw new \InvalidArgumentException(sprintf('The Payment_PaymentSearchData property can only contain items of type \patest\StructType\Payment_PaymentSearchData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Payment_PaymentSearchData[] = $this->{'Payment.PaymentSearchData'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\Payment_PaymentSearchData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\Payment_PaymentSearchData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\Payment_PaymentSearchData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\Payment_PaymentSearchData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\Payment_PaymentSearchData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Payment.PaymentSearchData
     */
    public function getAttributeName()
    {
        return 'Payment.PaymentSearchData';
    }
}
